// Processed by NMI's Java Code Viewer 4.8.3  1997-2000 B. Lemaire
// Website: http://njcv.htmlplanet.com	E-mail: info@njcv.htmlplanet.com
// Copy registered to Evaluation Copy
// Source File Name:   EducApplet.java

import java.applet.Applet;
import java.awt.*;
import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.StringTokenizer;
import java.util.Vector;

public class EducApplet extends Applet {

    private Vector v;
    private int nbObj;
    private int nbFound;
    private int nbTryes;
    private Font font;
    private TxtImg currentTxt;
    private TxtImg currentImg;
    int appWidth;
    int appHeight;

    public void init() {
        int i = 12;
        try {
            String s = getParameter("host");
            if(s == null)
                s = "localhost";
            String s1 = getParameter("dir");
            if(s1 == null)
                s1 = "educapplets/";
            String s2 = getParameter("file");
            if(s2 == null)
                s2 = "t1.html";
            String s3 = getParameter("fontsize");
            if(s3 != null)
                i = Integer.parseInt(s3);
            String s4 = "http://" + s + "/" + s1 + s2;
            URL url = new URL(s4);
            DataInputStream datainputstream = new DataInputStream(url.openStream());
            v = new Vector();
            String s5;
            while((s5 = datainputstream.readLine()) != null) 
                if(s5.indexOf(":") != -1) {
                    StringTokenizer stringtokenizer = new StringTokenizer(s5, ":", false);
                    String s6 = stringtokenizer.nextToken();
                    String s7 = stringtokenizer.nextToken();
                    TxtImg txtimg = new TxtImg(this, s6, s7);
                    v.addElement(txtimg);
                    System.out.println(s5 + " : " + s6 + " -> " + s7);
                }
            datainputstream.close();
        }
        catch(MalformedURLException malformedurlexception) {
            System.out.println("MalformedURLException: " + malformedurlexception);
        }
        catch(IOException ioexception) {
            System.out.println("IOException: " + ioexception);
        }
        nbObj = v.size();
        nbFound = 0;
        nbTryes = 0;
        font = new Font("Helvetica", 1, i);
        Rectangle rectangle = bounds();
        appHeight = rectangle.height;
        appWidth = rectangle.width;
        layOut();
        currentImg = currentTxt = null;
    }

    public void paint(Graphics g) {
        FontMetrics fontmetrics = g.getFontMetrics();
        g.setColor(Color.blue);
        g.drawRect(0, 0, appWidth - 1, appHeight - 1);
        g.setColor(Color.yellow);
        g.fillRect(1, 1, appWidth - 2, appHeight - 2);
        for(int i = 0; i < nbObj; i++) {
            TxtImg txtimg = (TxtImg)v.elementAt(i);
            txtimg.display(g, font);
        }

        String s = nbFound + "/" + nbTryes;
        g.setColor(Color.black);
        g.drawString(s, 501 - fontmetrics.stringWidth(s), fontmetrics.getHeight() + 2);
    }

    public synchronized boolean mouseUp(Event event, int i, int j) {
        for(int k = 0; k < nbObj; k++) {
            TxtImg txtimg = (TxtImg)v.elementAt(k);
            if(txtimg.inTxt(i, j) && !txtimg.found) {
                if(currentImg != null)
                    nbTryes++;
                if(currentTxt != null)
                    currentTxt.highText = false;
                currentTxt = txtimg;
                if(currentTxt == currentImg) {
                    txtimg.found = true;
                    nbFound++;
                    currentTxt.highText = currentImg.highImage = false;
                    currentTxt = currentImg = null;
                } else {
                    currentTxt.highText = true;
                    if(currentImg != null) {
                        currentImg.highImage = false;
                        currentImg = null;
                    }
                }
                break;
            }
            if(!txtimg.inImg(i, j) || txtimg.found)
                continue;
            if(currentTxt != null)
                nbTryes++;
            if(currentImg != null)
                currentImg.highImage = false;
            currentImg = txtimg;
            if(currentTxt == currentImg) {
                txtimg.found = true;
                nbFound++;
                currentTxt.highText = currentImg.highImage = false;
                currentTxt = currentImg = null;
            } else {
                currentImg.highImage = true;
                if(currentTxt != null) {
                    currentTxt.highText = false;
                    currentTxt = null;
                }
            }
            break;
        }

        repaint();
        if(nbFound == nbObj) {
            int l = (int)((20D * (double)(float)nbFound) / (double)(float)nbTryes);
            String s;
            if(l >= 15)
                s = "Bien!";
            else
            if(l >= 10)
                s = "Pas mal!";
            else
                s = "Applique toi!";
            AlertFrame alertframe = new AlertFrame("\n" + s + "\nTa note = " + l + "/20" + "\n\nClique sur OK pour continuer.", "Gagn\351!!");
            alertframe.show();
            currentTxt = currentImg = null;
            nbFound = nbTryes = 0;
            for(int i1 = 0; i1 < nbObj; i1++) {
                TxtImg txtimg1 = (TxtImg)v.elementAt(i1);
                txtimg1.found = txtimg1.highText = txtimg1.highImage = false;
            }

            layOut();
            sleep(1000);
            repaint();
        }
        return true;
    }

    public void sleep(int i) {
        try {
            Thread.sleep(i);
            return;
        }
        catch(InterruptedException _ex) {
            System.out.println("sleep interruted");
        }
    }

    public void layOut() {
        int i = 0;
        int j = 0;
        int k = 0;
        int l = 0;
        byte byte0 = 5;
        byte byte1 = 5;
        byte byte2 = 50;
        byte byte3 = 10;
        byte byte4 = 5;
        byte byte5 = 5;
        Graphics g = getGraphics();
        g.setFont(font);
        FontMetrics fontmetrics = g.getFontMetrics();
        for(int i2 = 0; i2 < nbObj; i2++) {
            TxtImg txtimg = (TxtImg)v.elementAt(i2);
            if(txtimg.wi > k)
                k = txtimg.wi;
            i += txtimg.hi;
            if(fontmetrics.stringWidth(txtimg.txt) > l)
                l = fontmetrics.stringWidth(txtimg.txt);
            j += fontmetrics.getHeight() + byte4;
            txtimg.setSize(fontmetrics.stringWidth(txtimg.txt) + byte5, fontmetrics.getHeight() + byte4);
        }

        int i1;
        if(i > j)
            i1 = i + (nbObj - 1) * byte3;
        else
            i1 = j + (nbObj - 1) * byte3;
        if(i1 > appHeight) {
            AlertFrame alertframe = new AlertFrame("pas assez de place! (" + i1 + "/" + appHeight + ")", "PROBLEME !!");
            alertframe.show();
        }
        int j1 = (i1 - j) / (nbObj - 1);
        int k1 = (i1 - i) / (nbObj - 1);
        int l1 = byte0 + l + byte5 + byte2;
        int j2 = byte1;
        int k2 = byte1;
        RandomIndex randomindex = new RandomIndex(nbObj);
        for(int l2 = 0; l2 < nbObj; l2++) {
            TxtImg txtimg1 = (TxtImg)v.elementAt(randomindex.getIndex());
            txtimg1.setTPos(byte0, j2);
            j2 += fontmetrics.getHeight() + byte4 + j1;
        }

        randomindex = new RandomIndex(nbObj);
        for(int i3 = 0; i3 < nbObj; i3++) {
            TxtImg txtimg2 = (TxtImg)v.elementAt(randomindex.getIndex());
            txtimg2.setIPos(l1, k2);
            k2 += txtimg2.hi + k1;
        }

    }

    public EducApplet() {
    }
}
